require 'logstash-logger'

module StartHer
  module Logger
    module_function

    def instance
      send(StartHer.env)
    end

    def development
      LogStashLogger.new(type: :stdout, formatter: ::Logger::Formatter)
    end

    def production
      LogStashLogger.new(type: :stdout, formatter: :json).tap do |logger|
        logger.level = ::Logger::INFO
      end
    end
    class << self
      alias_method :staging, :production
      alias_method :test, :development
    end
  end
end
