require 'redis'
require 'redis-namespace'
require 'msgpack'

module StartHer
  module RedisClient
    include StartHer::RetryPolicies

    private

    def client(options = {})
      options = client_opts(options)
      client = ::Redis.new(options)

      if (namespace = options[:namespace])
        ::Redis::Namespace.new(namespace, redis: client)
      else
        client
      end
    end

    def client_opts(options)
      StartHer.config.redis.merge(options).dup.tap do |opts|
        if opts[:network_timeout]
          opts[:timeout] = opts[:network_timeout]
          opts.delete(:network_timeout)
        end

        opts[:driver] = opts[:driver] || 'ruby'
      end
    end
  end
end
