module StartHer
  module RetryPolicies
    # rubocop:disable Metrics/AbcSize,Metrics/MethodLength
    def exponential_backoff(opts = {}, *exception_classes)
      options = { elapsed_time_secs: 600, multiplier: 2 }
      options.merge!(opts)

      time = 0.2
      started_at = Time.now.utc

      begin
        yield
      rescue *exception_classes => ex
        raise ex if (Time.now.utc - started_at) >= options[:elapsed_time_secs]
        sleep(time)

        time *= options[:multiplier]
        if (Time.now.utc - started_at) + time >= options[:elapsed_time_secs]
          time = options[:elapsed_time_secs] - (Time.now.utc - started_at)
        end

        retry
      end
    end
    # rubocop:enable Metrics/AbcSize,Metrics/MethodLength
  end
end
